"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class InterpretationData(ProtocolElement):
    """
    Represents the set of all interpretation data (excluding file
    contents) to be stored in MDT for         one TieringResult.
    Semantic restrictions (not automatically verifiable):
    - All InterpretedGenomesRD in interpretationResults refer to the
    TieringResult tieringResult.             - All
    InterpretedGenomesRD in interpretationResults have passed the QC
    stage and have been               approved by the originating GMCs
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "interpretationResults",
        "tieringResult",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_4_0_0 import reports as reports_4_0_0

        return {
            "interpretationResults": reports_4_0_0.InterpretedGenomeRD,
            "tieringResult": reports_4_0_0.TieringResult,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_4_0_0 import reports as reports_4_0_0

        return {
            "org.gel.models.report.avro.InterpretedGenomeRD": reports_4_0_0.InterpretedGenomeRD,
            "org.gel.models.report.avro.TieringResult": reports_4_0_0.TieringResult,
            "org.gel.models.report.avro.InterpretationData": reports_4_0_0.InterpretationData,
        }

    __slots__ = [
        "interpretationResults",
        "tieringResult",
    ]

    def __init__(
        self,
        interpretationResults,
        tieringResult,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_4_0_0.InterpretationData model.

        :param interpretationResults:
        :type interpretationResults: list[InterpretedGenomeRD]
        :param tieringResult:
        :type tieringResult: TieringResult
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "4.0.0"
